#include "ServoOOP.h"

#define WMIN 1000
#define WMITTE 1500
#define WMAX 2000
#define SCHRITTE 1000

//Mode 8
//Phasen- und Frequenz-korrekt
//WGM1   3 2 1 0
//       1 0 0 0
//ICR1=..... TOP
//fpwm = fclk/(2*N*TOP)
//Vorteilung
//N=8
//80Hz = 16000000/(2*8*TOP)
//TOP = 16000000/(2*8*80Hz)=12500

//dt==1000ms*(1/80Hz)/12500 == 0,001ms (1 Schritt == 0,001ms)
//=>
//1ms == 1000 Schritte
//1,5ms == 1500 Schritte
//2ms == 2000 Schritte

ServoOOP servo;

void setup() 
{
    Serial.begin(9600);

    servo.start();
    schlagAB();
}

void schlagA()
{
  servo.startA();
  servo.setzeWertA(1800);
  delay(100);
  servo.setzeWertA(2550);
  delay(120);
  servo.setzeWertA(1800);
  delay(100);
  servo.stopA();
}

void schlagB()
{
  servo.startB();
  servo.setzeWertB(1200);
  delay(100);
  servo.setzeWertB(1620);
  delay(120);
  servo.setzeWertB(1200);
  delay(100);
  servo.stopB();
}

void schlagAB()
{
  servo.startA();
  servo.startB();
  servo.setzeWertA(1800);
  servo.setzeWertB(1200);
  delay(100);
  servo.setzeWertA(2550);
  servo.setzeWertB(1620);
  delay(120);
  servo.setzeWertA(1800);
  servo.setzeWertB(1200);
  delay(100);
  servo.stopA();
  servo.stopB();
}

void loop() 
{
  
  if(Serial.available())
  {
      int c = Serial.read();
      if(c=='A')
          schlagA();
      else if(c=='B')
          schlagB();
      else if(c=='C')
      {
          schlagAB();
      }
  }
  /*
  schlagA();
  schlagB();
  schlagAB();
  */
}
