import processing.video.*;
import processing.serial.*;

Serial myPort;  // Create object from Serial class
int val;        // Data received from the serial port
Capture cam;
int BREITE = 640;
int HOEHE = 480;
public void setup()
{
    cam = new Capture(this,BREITE,HOEHE,"/dev/video0",30);
    cam.start();
  
    size(700,700);
    frameRate(30);
    
    String[] portNames = Serial.list();
    for(int i=0;i<portNames.length;i++)
        println(portNames[i]);
    
    myPort = new Serial(this, "/dev/ttyACM0", 9600);
    
}

int[] pix;
int[][] bild_neu = new int[HOEHE][BREITE];
int[][] bild_alt = new int[HOEHE][BREITE];
int[][] bild =     new int[HOEHE][BREITE];

int zaehlerA = 0;
int zaehlerB = 0;

public void draw()
{
    background(0);
//    myPort.write('A');              // send an H to indicate mouse is over square
    if (cam.available() == true) 
    {
        cam.read();
        cam.updatePixels();
        pix = cam.pixels;
        for(int i=0;i<bild.length;i++)
           for(int k=0;k<bild[i].length;k++)
               bild_alt[i][k] = bild_neu[i][k];
        for(int i=0;i<pix.length;i++)
        {
            int zeile = i/BREITE;
            int spalte = i%BREITE;
        
            bild_neu[zeile][BREITE-spalte-1] = pix[i];
        }
        
        for(int i=0;i<bild.length;i++)
        {
            for(int k=0;k<bild[i].length;k++)
            {
                int rotanteil_alt   = (int)red(bild_alt[i][k]);
                int rotanteil_neu   = (int)red(bild_neu[i][k]);

                if( abs(rotanteil_alt - rotanteil_neu) > 50 )
                    bild[i][k] = 255;
                else    
                    bild[i][k] = 0;
            }    
        }
        
    }

  stroke(255,0,0);
  line(BREITE/3,0,BREITE/3,HOEHE);
  line(2*BREITE/3,0,2*BREITE/3,HOEHE);
    
  noStroke();
  fill(255);
  for(int i=0;i<bild.length;i++)  
  {
       for(int k=0;k<bild[i].length;k++)
       {
            
               //fill(bild[i][k]);
               if(bild[i][k]==255)
                   rect(k,i,1,1);
       }    
  }
  int stelleA=-1;
  for(int i=0;i<HOEHE;i++)
  {
        if(bild[i][BREITE/3]>0)
        {
             stelleA=i;
             break;
        }
  }
  
  int stelleB=-1;
  for(int i=0;i<HOEHE;i++)
  {
        if(bild[i][2*BREITE/3]>0)
        {
             stelleB=i;
             break;
        }
  }

  if(stelleA>-1 && stelleB>-1 && zaehlerA==0 && zaehlerB==0)
  {
       zaehlerA = 15;
       zaehlerB = 15;
       myPort.write('C');       
  }
  else if(stelleA>-1 && zaehlerA==0 && zaehlerB==0)
  {
       zaehlerA = 15;
       myPort.write('A');       
  }
  else if(stelleB>-1 && zaehlerA==0 && zaehlerB==0)
  {
       zaehlerB = 15;
       myPort.write('B');       
  }
  
  if(zaehlerA>0)
     zaehlerA--;
  if(zaehlerB>0)
     zaehlerB--;
}